<?php
/**
 * $Horde: odin/addobject.php,v 1.16 2005/01/03 14:35:23 jan Exp $
 *
 * Odin: Copyright 2000-2005 Charles J. Hagenbuch <chuck@horde.org>
 *
 * You should have received a copy of the GNU Public
 * License along with this package; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

@define('ODIN_BASE', dirname(__FILE__));
require_once ODIN_BASE . '/lib/base.php';
require_once ODIN_BASE . '/lib/Source.php';
require_once ODIN_BASE . '/lib/ObjectView.php';
require_once ODIN_BASE . '/lib/Object.php';

$title = _("Add a new row");
require ODIN_TEMPLATES . '/common-header.inc';
require ODIN_TEMPLATES . '/menu.inc';

$source = Util::getFormData('source');
if ($source == null || !isset($cfgSources[$source])) {
    $options = '';
    $count = 0;
    foreach ($cfgSources as $key => $curSource) {
        if (empty($curSource['readonly']) || (isset($curSource['admin']) && in_array(Auth::getAuth(), $curSource['admin']))) {
            $options .= '<option value="' . $key . '">' . $curSource['title'] . '</option>';
            $source = $key;
            $count++;
        }
    }
} else {
    $count = 1;
}

if ($count == 0) {
    require ODIN_TEMPLATES . '/add/noadd.inc';
} elseif ($count == 1) {
    $driver = &Odin_Source::singleton($source, $cfgSources[$source]);
    if (PEAR::isError($driver)) {
        Horde::logMessage($driver, __FILE__, __LINE__, PEAR_LOG_ERR);
        $notification->push(_("Failed to connect to the specified data source."), 'horde.error');
        $notification->notify(array('listeners' => 'status'));
    } else {
        $object = &new Odin_Object($driver);
        $view = &new Odin_ObjectView($object, ODIN_TEMPLATES . '/add/add.inc');
        $view->display();
    }
} else {
    require ODIN_TEMPLATES . '/add/select.inc';
}

require $registry->get('templates', 'horde') . '/common-footer.inc';
