<?php
/**
 * $Horde: odin/addobjectaction.php,v 1.12 2005/01/03 14:35:23 jan Exp $
 *
 * Odin: Copyright 2000-2005 Charles J. Hagenbuch <chuck@horde.org>
 *
 * You should have received a copy of the GNU Public
 * License along with this package; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

@define('ODIN_BASE', dirname(__FILE__));
require_once ODIN_BASE . '/lib/base.php';
require_once ODIN_BASE . '/lib/Source.php';
require ODIN_BASE . '/config/attributes.php';

global $prefs;

$source = Util::getFormData('source');
$driver = &Odin_Source::singleton($source, $cfgSources[$source]);
$object = Util::getFormData('object');
foreach ($object as $key => $value) {
    if (isset($attributes[$key]) && $attributes[$key]['type'] == 'date') {
        if ($value['month'] == '' || $value['day'] == '' || $value['year'] == '') {
            $object[$key] = null;
        } else {
            $object[$key] = mktime(0, 0, 0, $value['month'], $value['day'], $value['year']);
        }
    }
}

/* Create Object */
$key = $driver->addObject($object);

if (!is_a($key, 'PEAR_Error')) {
    $url = Util::addParameter('displayobject.php', 'source=' . urlencode($source));
    $url = Util::addParameter($url, 'key=' . urlencode($key));
    header('Location: ' . Horde::applicationUrl($url, true));
    exit;
}

Horde::logMessage($key, __FILE__, __LINE__, PEAR_LOG_ERR);
$notification->push(_("There was an error adding this object. Contact your system administrator for further help."), 'horde.error');

$title = _("Add failed");
require ODIN_TEMPLATES . '/common-header.inc';
require ODIN_TEMPLATES . '/menu.inc';
require $registry->get('templates', 'horde') . '/common-footer.inc';
