<?php
/**
 * $Horde: odin/summary.php,v 1.15 2005/01/03 14:35:23 jan Exp $
 *
 * Odin: Copyright 2000-2005 Charles J. Hagenbuch <chuck@horde.org>
 *
 * You should have received a copy of the GNU Public
 * License along with this package; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

@define('ODIN_BASE', dirname(__FILE__));
require_once ODIN_BASE . '/lib/base.php';
require_once ODIN_BASE . '/lib/Source.php';
require ODIN_BASE . '/config/attributes.php';

$title = _("Data Summaries");
require ODIN_TEMPLATES . '/common-header.inc';
require ODIN_TEMPLATES . '/menu.inc';

$source = Util::getFormData('source');
if ($source == null || !isset($cfgSources[$source])) {
    $options = '';
    $count = 0;
    foreach ($cfgSources as $key => $curSource) {
        if (!empty($curSource['summary'])) {
            $options .= '<option value="' . $key . '">' . $curSource['title'] . '</option>';
            $source = $key;
            $count++;
        }
    }
} else {
    $count = 1;
}

if ($count == 0) {
    require ODIN_TEMPLATES . '/summary/nosummary.inc';
} elseif ($count == 1) {
    $driver = &Odin_Source::singleton($source, $cfgSources[$source]);
    if (PEAR::isError($driver)) {
        Horde::logMessage($driver, __FILE__, __LINE__, PEAR_LOG_ERR);
        $notification->push(_("Failed to connect to the specified data source."), 'horde.error');
        $notification->notify(array('listeners' => 'status'));
    } else {
        foreach ($cfgSources[$source]['summary'] as $id => $summary) {
            $input = Util::getFormData($id);
            if (empty($summary['input']) || !empty($input)) {
                if (!is_null($input)) {
                    switch ($attributes[$summary['input']]['type']) {
                    case 'yyyymmdd':
                        $input = sprintf('%04d%02d%02d', $input['year'], $input['month'], $input['day']);
                        break;
                    case 'hh:mm:ss':
                        $input = sprintf('%02d:%02d:%02d', $input['hour'], $input['min'], '00');
                        break;
                    }
                }

                $result = $driver->runSummary($summary, $input);
                require ODIN_TEMPLATES . '/summary/summary.inc';
            } else {
                require ODIN_TEMPLATES . '/summary/input.inc';
            }
        }
    }
} else {
    require ODIN_TEMPLATES . '/summary/select.inc';
}

require $registry->get('templates', 'horde') . '/common-footer.inc';
